{
'success';
}

###########################################################################
sub disp_login_promt {
###########################################################################
   my $template = Template->new ({
        INCLUDE_PATH  => $include_path,
        RELATIVE => 1, 
        ABSOLUTE => 1,
        PRE_PROCESS => "$include_path/config",
      });

   my $vars = {
        'url'           => $url,
        'SITE_IP'       => $SITE_IP,
        'index'         => $index,
                };
  print "Content-type: text/html\n\n";
  $template->process ('cp_login', $vars) || die $template->error(), "\n";

}

###########################################################################
sub edit_user_form {
###########################################################################
   my $template = Template->new ({
        INCLUDE_PATH  => $include_path,
        RELATIVE => 1, 
        ABSOLUTE => 1,
        PRE_PROCESS => "$include_path/config",
      });

   my $vars = {
        'main_list'     => \@MAIN_LIST,
        'top_item'      => $top_item,
        'last_item'     => $last_item,
        'last_hash'     => $last_hash,
        'path'          => $p,
        'url'           => $cp,
        'SITE_IP'       => $SITE_IP,
        'index'         => $index,
        'field'         => $field,
        'sub'           => $sub,
        'page'          => $page,
        'left_nav'      => &get_left_nav(),

        'FORM'          => \%FORM,

        'USER'          => $USER,
        'U_NAME'        => $name1,
        'valid_user'    => $valid_user,
        'superuser_mode'=> $superuser_mode,
        'url'           => $url,

        'user'          => &get_user_form(),
                };
  print "Content-type: text/html\n\n";
  $template->process ('cp_user', $vars) || die $template->error(), "\n";
}
 
###########################################################################
sub get_user_form {
###########################################################################
 my $pwd = '';
 my @users = ();
 my $passwd_line = '';
 my $username = '';
 my $passwd = '';
 my $name1 = '';
 my $acc = '';
 my $ml = '';
 my $f='';
 my $h='';
 my $act_u = '';
 my $s='';
 my $subm = '';

 if ($FORM{'act'} eq 'u_del') {
    $act_u = "u_del_a";
    $subm ="Delete";
 }
 else {
    $act_u = "u_edit_a";
    $subm = "Edit";
 }

 if (!$FORM{'u_name'} || $FORM{'u_name'} eq '') {&error (bad_data, "empty user name");}
 open (PASSWD, "$start_path/$passwd_file") || &error(file_not_found, $!);
 @users = <PASSWD>;
 close(PASSWD);

 foreach $passwd_line (@users) {
   chop($passwd_line) if $passwd_line =~ /\n$/;
   if ($passwd_line !~ /^\#/) {
      $username = '';
      $passwd = '';
      $name1 = '';
      $acc = '';

      $passwd_line =~ s/
//g;
      ($username,$passwd,$name1,$acc, $ml) = split(/:/, $passwd_line, 5);

      if ($username =~ /$FORM{'u_name'}/si) {

         if ($acc =~ /yes/i) {
           $s = "checked";
         }

         my $res = {
                'act'           => $act_u,
                'submit'        => $subm,
                'u_name'        => $username,
                'u_fullname'    => $name1,
                'su'            => $s,
                'u_email'       => $ml,
                };
         return $res;
       }
    }
  }  

  return undef;
}

###########################################################################
sub add_user_form {
###########################################################################
   my $template = Template->new ({
        INCLUDE_PATH  => $include_path,
        RELATIVE => 1, 
        ABSOLUTE => 1,
        PRE_PROCESS => "$include_path/config",
      });

   my $vars = {
        'main_list'     => \@MAIN_LIST,
        'top_item'      => $top_item,
        'last_item'     => $last_item,
        'last_hash'     => $last_hash,
        'path'          => $p,
        'url'           => $cp,
        'SITE_IP'       => $SITE_IP,
        'index'         => $index,
        'field'         => $field,
        'sub'           => $sub,
        'page'          => $page,
        'left_nav'      => &get_left_nav(),

        'USER'          => $USER,
        'U_NAME'        => $name1,
        'valid_user'    => $valid_user,
        'superuser_mode'=> $superuser_mode,
        'url'           => $url,

        'users'          => &get_users(),
                };

  print "Content-type: text/html\n\n";
  $template->process ('cp_add_list_users', $vars) || die $template->error(), "\n";
}

###########################################################################
sub get_users {
###########################################################################
 
 my $pwd = '';
 my @users = ();
 my $passwd_line = '';
 my $username = '';
 my $passwd = '';
 my $name1 = '';
 my $acc = '';
 my $ml = '';

 open (PASSWD, "$start_path/$passwd_file") || &error(file_not_found, $!);
 @users = <PASSWD>;
 close(PASSWD);

 my @res = undef;

 foreach $passwd_line (@users) {

   chop($passwd_line) if $passwd_line =~ /\n$/;
   if ($passwd_line !~ /^\#/) {

      $username = '';
      $passwd = '';
      $name1 = '';
      $acc = '';
  
      $passwd_line =~ s/
//g;
      ($username, $passwd, $name1, $acc, $ml) = split(/:/, $passwd_line, 5);
      
      $edit ="<a href=http://$SITE_IP/$cpanel?act=u_edit\&u_name=$username>Edit</a>";
      $delete ="<a href=http://$SITE_IP/$cpanel?act=u_del\&u_name=$username>Delete</a>";

      my $t = { 
        'name1'         => $name1,
        'acc'           => $acc,
        'edit'          => $edit,
        'delete'        => $delete,
        'ml'            => $ml,
        'username'      => $username,
        };

      push @res, $t;
   }
 }  
 
 return \@res;
}

###########################################################################
sub add_user_act {
###########################################################################
 my $pwd = '';
 my @users = ();
 my $passwd_line = '';
 my $username = '';
 my $passwd = '';
 my $name1 = '';
 my $acc = '';
 my $ml = '';

 &error (bad_data, "password check : difference found") 
         if $FORM{'ps1'} ne $FORM{'ps2'};
 &error (bad_data, "password check : empty value") if $FORM{'ps1'} eq '' ;
  
 open (PASSWD, "$start_path/$passwd_file") || &error(file_not_found, $!);
 @users = <PASSWD>;
 close(PASSWD);

 # check duplications
 foreach $passwd_line (@users) {
   chop($passwd_line) if $passwd_line =~ /\n$/;
   if ($passwd_line !~ /^\#/) {
      $username = '';
      $passwd = '';
      $name1 = '';
      $acc = '';
      $ml = '';
  
      $passwd_line =~ s/
//g;
      ($username,$passwd,$name1,$acc,$ml) = split(/:/, $passwd_line, 5);
  
      if ($username =~ /$FORM{'u_name'}/si) {
         &error (bad_data, "This user already registered");
      }
   }
 }

 $pwd = crypt($FORM{'ps1'}, time);
 $acc = $FORM{'su'} ? 'yes' : 'no';

 $FORM{'u_name'} =~ s/ //g;
 $FORM{'u_email'} =~ s/ //g;

 open (PASSWD, ">>$start_path/$passwd_file") || &error(file_not_found, $!);
 flock(PASSWD, LOCK_EX);
 print PASSWD "$FORM{'u_name'}:$pwd:$FORM{'u_fullname'}:$acc:$FORM{'u_email'}\n";
 flock(PASSWD, LOCK_UN);
 close(PASSWD);
 &report_auth ("User $FORM{'u_name'} created.");

 my $mail_body=<<END;
==== $main_name:
New user added:

userID=$FORM{'u_name'};
password=$FORM{'ps1'};
name=$FORM{'u_fullname'};
mail=$FORM{'u_email'};

addr=$ip_address;
host=$hostname;
date=$date;

Please use this link: http://$SITE_IP/$cpanel?act=login
to login!

Please remember the userID and password, any questions - 
mail to $def_to_addr.

END
&mail_to ($FORM{'u_email'}, $def_to_addr, 
          "$main_name got a NEW USER!", $mail_body);
}

###########################################################################
sub mail_to {
###########################################################################
my ($to_addr, $bcc_addr, $subj, $body) = @_;

  my $t_addr = $def_to_addr;
  my $s = "no subject";

  $t_addr = $to_addr if ($to_addr ne '');
  $s = $subj if ($subj ne '');

  open (TF, "$email_command");
  print TF "To: $t_addr\n";
  print TF "From: $from_addr\n";
  print TF "Bcc: $bcc_addr\n" if ($bcc_addr ne '');
  print TF "Subject: $s\n\n";  
  print TF $body;
  close TF;

  &report ("sent mail to $t_addr");
}

###########################################################################
sub edit_user_act {
###########################################################################
 my $pwd = '';
 my @users = ();
 my $passwd_line = '';
 my $username = '';
 my $passwd = '';
 my $name1 = '';
 my $acc = '';
 my $ml = '';
 my $done = 0;

 open (PASSWD, "$start_path/$passwd_file") || &error(file_not_found, $!);
 @users = <PASSWD>;
 close(PASSWD);

 open (PASSWD, ">$start_path/$passwd_file") || &error(file_not_found, $!);
 flock(PASSWD, LOCK_EX);
 foreach $passwd_line (@users) {
   chop($passwd_line) if $passwd_line =~ /\n$/;
   if ($passwd_line !~ /^\#/) {
      $username = '';
      $passwd = '';
      $name1 = '';
      $acc = '';
      $ml = '';
  
      $passwd_line =~ s/
//g;
      ($username,$passwd,$name1,$acc,$ml) = split(/:/, $passwd_line, 5);
  
      if ($username =~ /$FORM{'u_name'}/si) {
         $done=1;
         if ($FORM{'act'} eq 'u_edit_a') {
            $acc = $FORM{'su'} ? 'yes' : 'no';
            print PASSWD "$FORM{'u_name'}:$passwd:$FORM{'u_fullname'}:$acc:$FORM{'u_email'}\n";
    &report_auth ("User data for $username updated.");

    my $mail_body =<<END;
==== $main_name:
User data changed :

userID=$FORM{'u_name'};
name = $FORM{'u_fullname'};
mail=$FORM{'u_email'};

addr=$ip_address;
host=$hostname;
date=$date;

Please use this link: http://$SITE_IP/$cpanel?act=login
to login!

Mail to $def_to_addr if you have any questions.

END
        &mail_to ($FORM{'u_email'}, $def_to_addr, 
                  "$main_name - userdata changed", $mail_body);
         }
         else {
    &report_auth ("User $username Deleted."); 
         }
      }
      else {
         print PASSWD "$passwd_line\n";
      }  
   }
   else {
      print PASSWD "$passwd_line\n";
   }      
 }

 flock(PASSWD, LOCK_UN);
 close(PASSWD);

 if (!$done) {
    &report_auth ("User data not updated");
 }
}

###########################################################################
sub change_pwd_act {
###########################################################################
 my $pwd = '';
 my @users = ();
 my $passwd_line = '';
 my $username = '';
 my $passwd = '';
 my $name1 = '';
 my $acc = '';
 my $ml = '';

 &error (bad_data, "password check : difference found") if $FORM{'pas1'} ne $FORM{'pas2'};
 &error (bad_data, "password check : empty value") if $FORM{'pas1'} eq '' ;

 $pwd = crypt($FORM{'pas1'}, time);
  
 open (PASSWD, "$start_path/$passwd_file") || &error(file_not_found, $!);
 @users = <PASSWD>;
 close(PASSWD);

 open (PASSWD, ">$start_path/$passwd_file") || &error(file_not_found, $!);
 flock(PASSWD, LOCK_EX);

 foreach $passwd_line (@users)
 {
    chop ($passwd_line) if $passwd_line =~ /\n$/;

    if ($passwd_line =~ /^\#/) {
       print PASSWD $passwd_line;
    }
    else
    {  
       $passwd_line =~ s/
//g;

       ($username, $passwd, $name1, $acc, $ml) = split(/:/,$passwd_line,5);

       if ($username =~ /$USER/si) {
          print PASSWD "$username:$pwd:$name1:$acc:$ml\n";
          &report_auth ("User password changed");
          my $mail_data =<<END;
==== $main_name:
User password changed :

userID=$username;
name=$name1;
mail=$ml;

NEW PASSWORD=$FORM{'pas1'};

addr=$ip_address;
host=$hostname;
date=$date;

Please use this link: http://$SITE_IP/$cpanel?act=login
to login!

Please remember the new password.
Mail to $def_to_addr if you have any questions.

END
        &mail_to ($ml, $def_to_addr, 
                  "$main_name - password changed", $mail_data);
 
       }
       else {
          print PASSWD $passwd_line."\n";
       }
    }
 }
   
 flock(PASSWD, LOCK_UN);
 close(PASSWD);
}


###########################################################################
sub remove_session {
###########################################################################
  if ($USER ne '') {
     &delete_old_session;
  }
}

###########################################################################
sub delete_old_session {
###########################################################################
  my  @old_f = ();
  my  $item1 = '';

  opendir (DIR, "$tmp_dir");
  @old_f = grep {/$USER/ && -f "$tmp_dir/$_" } readdir(DIR);
  closedir DIR;
 
  foreach $item1 (@old_f) {
     if ($item1 ne '') {
        unlink "$tmp_dir/$item1"; 
     }
  }
}

###########################################################################
sub check_passwd {
###########################################################################
   my $ok = 0;
   my $acc = '';
   my $cookie = '';
   my $is_cook = 0;
   my $username = '';

   $session_id = 0;

   if ($USER eq '' || !$USER) {
      $cookie=&get_cookie($c_pwd_name);

      if ($cookie eq '') {
         &report_auth ("attend to login w/o username or cookie");
         &error (bad_user_name, "Access not allowed - please relogin.");
      }
   
      ($USER, $session_id) = split(/-/, $cookie, 2);
      if (!$USER) 
      {
         $USER = '';
      }
   }

   if ($session_id > 0) {
      if (! -e "$tmp_dir/$USER.$session_id") {
         print "Location: http://$SITE_IP/$cpanel?act=login\n\n";
         &report_auth (" no session id file. ");
         exit;
      }

      open (SESSIONID, "$tmp_dir/$USER.$session_id") || 
            &error (file_not_found, "Session id : $!");

      $valid_user = 1;
      $is_cook = 1;
 
      $ok = 1;
   }

   if (!$USER || $USER eq '') {
      print "Location: http://$SITE_IP/$cpanel?act=login\n\n";
      &report_auth (" no username. ");
      exit;
   }
  
   if (-e "$start_path/$passwd_file")
   {
      open (PASSWD, "$start_path/$passwd_file") || &error(file_not_found, $!);
      @users = <PASSWD>;
      close(PASSWD);
   }
   else {

      $passwd = crypt($pwd, time);
  
      open (PASSWD, ">$start_path/$passwd_file") || 
           &error(file_not_found, "$start_path/$passwd_file : $!");

      print PASSWD "$USER:$passwd:Superuser:YES:$from_addr\n";
      close(PASSWD);
      &report_auth (" User file created.");
      &error("", " NEW user file created  - please relogin");
   }

   foreach $passwd_line (@users)
   {
      chop($passwd_line) if $passwd_line =~ /\n$/;
      if ($passwd_line !~ /^\#/) {
       
       $username = '';
       $passwd = '';
       $name1 = '';
       $acc = '';
       $ml = '';

       $passwd_line =~ s/
//g;
       ($username,$passwd,$name1,$acc,$ml) = split(/:/,$passwd_line,5);

       if ($valid_user == 1 && $username eq $USER) {
          if ($acc =~ /yes/i) {
            $superuser_mode = 1;
          }

          &report_auth (" logged (id=$session_id), su=$acc ($superuser_mode), c=$is_cook");
          return $USER;
       }
     
       $test_passwd = crypt ($pwd, $passwd);

       if ($test_passwd eq $passwd && $USER eq $username)
       {
         $ok = 1;

         $USER=$username;
         $session_id = rand (30000);
         &set_cookie ($c_pwd_name, $USER.'-'.$session_id, 24);


         &delete_old_session;
         open (SESSIONID, ">$tmp_dir/$USER.$session_id") || 
               &error (file_not_found, " Session id : $! ");
         close SESSIONID;

         $valid_user = 1;
 
         if ($acc =~ /yes/i) {
            $superuser_mode = 1;
         }

         &report_auth (" logged (id=$session_id), su=$acc ($superuser_mode), c=$is_cook");
         return $USER;
       }
     }
   }

   if ($ok == 0)
   {
      $valid_user = 0;
      &remove_session;
      &remove_cookie ($c_pwd_name);
      print "Location: http://$SITE_IP/$cpanel?act=login\n\n";
      &report_auth (" going out.");
      exit;
   }
   else {
      &report_auth (" logged (id=$session_id), su=$acc ($superuser_mode), c=$is_cook");
   }
}
