#!/usr/local/bin/perl
{

 'success';
}

###########################################################################
sub get_date_by_val {
###########################################################################
 my ($tt) = @_;
 my %mn = ('Jan','01', 'Feb','02', 'Mar','03', 'Apr','04',
        'May','05', 'Jun','06', 'Jul','07', 'Aug','08',
        'Sep','09', 'Oct','10', 'Nov','11', 'Dec','12' );
 my $sydate=localtime($tt);
 my ($day, $month, $num, $time, $year) = split(/\s+/,$sydate);
 my $zl=length($num);
    if ($zl == 1) { $num = "0$num";}
 my $retval = "$num $month $year, $time";
 return $retval;
}


###########################################################################
sub get_recent_list {
###########################################################################
 my @rr = &get_recent_data;
 my ($dd1, $t1, $line, $link, $ti);
 my @ret;
 my $tex;

 foreach $line (@rr) {
   ($dd1, $t1) = split (';', $line, 2);
   $link = "http://$SITE_IP/$index/$t1";
   $ti = &get_date_by_val ($dd1);

   my $tex = { 'link' => $link,
               'time' => $ti};

   push @ret, $tex;
 }

 if (!@ret) {return ();}

 return \@ret;
}
 
###########################################################################
sub cmp_item_date {
###########################################################################
   my ($dd1, $t1) = split (';', $a, 2);
   my ($dd2, $t2) = split (';', $b, 2);

   return ($dd2 cmp $dd1);
}

###########################################################################
sub get_recent_data {
###########################################################################
 my $file = "$start_path/$data_dir/$recent_file";
# my $file = "./r.txt";
 my $cnt = 0;
 my @rr = ();
 my $line;
  
 open (DATA, $file) || return ();
 my @recent = <DATA>;
 close DATA;

 foreach $line (@recent) {
   if ($cnt < $MAX_RECENT && $line && $line ne '' && $line ne "\n") {
      $line =~ s/\n//g;
      push @rr, $line;
   }  

   $cnt++;
 }

 return @rr;
}
 
###########################################################################
sub recent_changed {
###########################################################################
 my $file = "$start_path/$data_dir/$recent_file";
 my $cnt = 0;
 my $tt = time;
 my $new_line = "$tt;$p";
 my ($dd1, $t1, $line);

 my @rr = &get_recent_data;

 $cnt = 0;
 my $found = 0;
 foreach $line (@rr) {
   ($dd1, $t1) = split (';', $line, 2);

   if ($t1 eq $p) {
      $rr[$cnt] = $new_line; $found = 1;
   }

   $cnt++;
 }
 
 if (!$found) { push @rr, $new_line; }

 my @rsorted = sort cmp_item_date @rr;

 open (DATA, ">$file");
 flock(DATA, LOCK_EX);

 foreach $line (@rsorted) {
    if ($line && $line ne '') {
       print DATA $line, "\n";
    }
 }

 flock(DATA, LOCK_UN);
 close DATA;
}
