{

'success';

}  

###########################################################################
sub get_html_file_name {
###########################################################################

#  &error (bad_data, "wrong type") if ($file_type ne $html_type);
  &error (bad_data, "Incorrect upload $p/page=$page") 
                                  if (!defined $last_hash);

  my ($filename, $dir, $gb_name_data) = &get_index_file_n_gb ($last_hash);     
  $filename =~ s/ //gs;

  return ($filename, $dir);
}   

###########################################################################
sub filter_file_name {
###########################################################################
  my $filename = shift;
  my @ff;
  my $res = $filename;

  if ($filename =~ /\\/ ) {
      @ff = split (/\\/, $filename);
      $res = pop @ff;
  }
 
  if ($filename =~ /\// ) {
      @ff = split (/\//, $filename);
      $res = pop @ff;
  } 

  $res =~ s/[~`'"<>\s]//g;

  return $res;
}

###########################################################################
sub get_file_from_type {
###########################################################################
  my ($file_type) = @_;
  my ($filename, $dir);
  my ($name, $f_type);
  
  return &get_html_file_name() if ($file_type eq $html_type || 
                                   !defined $file_type);

  if ($file_type eq $gr_type) {
     

     if (defined $FORM{'filename'}) {
        $filename = &filter_file_name ($FORM{'filename'})
     }
     else {
        &error (bad_data, "Missed file to upload");
     }    

     $f_type = $gr_type;
     $dir = $img_dir;

  }
  else {

     my @type = split (/_/, $file_type);

     $f_type = shift @type;
     $name  = join '_', @type;

     if (! defined $name  || $name eq '' || !$name) {

        if (defined $FORM{'filename'}) {
           $filename = &filter_file_name ($FORM{'filename'})
        }
        else {
           &error (bad_data, "No filename given");
        }   
     }
     else {
        $filename = &filter_file_name ($name);
     }

     &error (bad_data, "Incorrect file given.") if (! defined $filename || 
                                                     $filename eq '' || 
                                                     !$filename);

     $dir = $css_dir if ($f_type eq $css_type);
     $dir = $tt_dir if ($f_type eq $tt_type);
     $dir = $static_dir if ($f_type eq $static_type);
     $dir = $img_dir if ($f_type eq $gr_type);
  }

  return ($filename, $dir, $f_type);
}

###########################################################################
sub get_file {
###########################################################################
  my $file_type = $FORM{'f_type'};
  my ($filename, $dir, $strip_type) = &get_file_from_type ($file_type);
  my $tmp_data = &mktmpfile ($filename, $dir, $file_type, 
                             $strip_type, 'userfile');

  if ($file_type eq $html_type) {
     &report ("UPLOAD $p/?page=$page");
  }
  else {
     &report ("UPLOAD $strip_type $filename");
     $file_type = $strip_type."_".$filename;
  }

  &show_editor ($tmp_data->{'full_name'}, $tmp_data->{'link'},
                $file_type, $strip_type);

  exit 0;
}

###########################################################################
sub show_editor {
###########################################################################
   my ($tmp_file, $preview_link, $file_type, 
       $strip_type) = @_;

   my $template = Template->new ({
        INCLUDE_PATH  => $include_path,
        RELATIVE => 1, 
        ABSOLUTE => 1,
        PRE_PROCESS => "$include_path/config",
      });

   my $vars = {
        'main_list'     => \@MAIN_LIST,
        'top_item'      => $top_item,
        'last_item'     => $last_item,
        'last_hash'     => $last_hash,
        'path'          => $p,
        'url'           => $url,
        'SITE_IP'       => $SITE_IP,
        'index'         => $index,
        'field'         => $field,
        'sub'           => $sub,
        'print_msg'     => $MSG{'to_print'},
        'page'          => $page,
        'left_nav'      => &get_left_nav(),

        'file_to_show'  => $tmp_file, 
        'preview_link'  => $preview_link,
        'f_type'        => $file_type,
        'strip_type'    => $strip_type,
        'tmp_suffix'    => $suff,

        'FORM'          => \%FORM,

        'USER'          => $USER,
        'U_NAME'        => $name1,
        'valid_user'    => $valid_user,
        'superuser_mode'=> $superuser_mode,

#        'common_1'      => &get_common (1),
#        'common_2'      => &get_common (2),
#        'recent'        => &get_recent_list(),
#        'css'           => &get_css(),
#        'add_nav'       => &get_add_nav(),
#        'wiki_link'     => &get_wiki_link(),
#        'print_link'    => &get_print_link(),

#         'gb_body'       => &get_guestbook ($index, "mng_gb",
#                                            $gb_name_data, 1),

                };
  print "Content-type: text/html\n\n";
  $template->process ('cp_editor', $vars) || die $template->error(), "\n";

}
###########################################################################
sub update_file {
###########################################################################
  my $line;
  my $file_name;
  my $file_dir;
  my $file_data;
  my $file_type = $html_type;
  my @file_res = ();
  my $updated = 0;
  my $data = '';
  my ($file_name, $dir, $strip_type) = &get_file_from_type ($file_type);

#  my ($file_name, $dir, $gb_name_data) = &get_index_file_n_gb ($last_hash);
  $f_n = "$dir/$file_name";

  open (F, $f_n) || &error ("", "File \"$file_name\" : $!");
  @file_data =  <F>;
  close F;

  my %mn = ('Jan','01', 'Feb','02', 'Mar','03', 'Apr','04',
        'May','05', 'Jun','06', 'Jul','07', 'Aug','08',
        'Sep','09', 'Oct','10', 'Nov','11', 'Dec','12' );

  my $sydate = localtime (time);
  my ($day, $month, $num, $time, $year) = split(/\s+/,$sydate);
  my $zl = length ($num);

  if ($zl == 1) { $num = "0$num";}

  $data = "$num-$month-$year";
  my $news_but = "[<font size=-3 color=$linkcolor>$data</font>]<p>\n";

  if (defined $last_hash->{'NEWS_BUTT'} && 
      $last_hash->{'NEWS_BUTT'} ne '') {
     $news_but = $last_hash->{'NEWS_BUTT'};
     $news_but =~ s/<!--date-->/$data/si;
  }

  foreach $line (@file_data) {     
    push @file_res, $line;
    $hint = grep (/$magic_line/i, $line);
    if ($hint) {
       push @file_res, "$last_hash->{'NEWS_TOP'} $FORM{'gb_data'} $news_but";
       $updated = 1;
    }
  }

  &error ("", "Magic line nof found.") if ($updated < 1); 

  my $tmp_data = &get_tmp_data ($file_name, $dir, $strip_type, undef);

  $f_n = $tmp_data->{'full_name'};
  open (F, ">$f_n") || &error ("", "Cannot create temp file.");
  flock(F, LOCK_EX);

  foreach $line  (@file_res) {print F $line;}

  flock(F, LOCK_UN);
  close F;

  &report ("added news to temporary $file_name");
  &show_editor ($f_n, $tmp_data->{'link'}, $html_type, $html_type);

  exit 0;
}


###########################################################################
sub display_page {
###########################################################################
  my ($tmp, $page) = @_;

  return if ($field eq '' && $sub eq '' && $page eq '');
  if (defined $page && $page > $last_hash->{'PAGES'})
  {
     undef $page;
     undef $FORM{'page'};
     &report ("incorrect page number, use main document");
  }

  my ($filename, $dir, $strip_type) = &get_file_from_type ($html_type);

  if (!defined $tmp || $tmp eq '') {
     &show_editor ("$dir/$filename", undef, $html_type, $html_type);
  }
  else {
     my $tmp_data = &get_tmp_data ($filename, $dir, $strip_type, $tmp);

     &show_editor ($tmp_data->{'full_name'}, $tmp_data->{'link'}, 
                   $html_type, $html_type);
  }

  exit 0;
}

###########################################################################
sub edit_file_page {
###########################################################################
   my $f;
   my $d;
   my $page;
   my $tmp; 
   my $file_type;

   &check_access ($field, ($field < 0), $last_item,  "edit file");

   $page = $FORM{'page'} if (defined $FORM{'page'});

   $tmp = $FORM{'tmp_name'} if (defined $FORM{'tmp_name'} && 
                                           $FORM{'tmp_name'} ne '');

   $file_type = $FORM{'f_type'} if (defined $FORM{'f_type'} && 
                                           $FORM{'f_type'} ne '' &&
                                           $FORM{'f_type'});

   if ($page ne '' && $last_hash->{'PAGES'} > 0) {
      &display_page ($tmp, $page);
      exit;
   }  
    
   if ($FORM{'get'} eq '' && $p ne '') {
      &display_page ($tmp, $page);
      exit;
   }  
  
   if ($FORM{'get'} eq 'about') {
      $f = $about_file;
      $d = $static_dir;
      $t = $static_type;
      $f_t = $t."_".$f;
  }

   if ($FORM{'get'} eq 'contacts') {
      $f = $authors_file;
      $d = $static_dir;
      $t = $static_type;
      $f_t = $t."_".$f;

   }

   if ($FORM{'get'} eq 'area1') {
      $f = $common_area1;
      $d = $static_dir;
      $t = $static_type;
      $f_t = $t."_".$f;
   }

   if ($FORM{'get'} eq 'area2') {
      $f = $common_area2;
      $d = $static_dir;
      $t = $static_type;
      $f_t = $t."_".$f;
   }

   if (defined $file_type && !defined $f) {
      my ($filename, $dir, $strip_type) = &get_file_from_type ($file_type);

      $f = $filename;
      $d = $dir;
      $t = $strip_type;
      $f_t = $file_type;
   }

   if (defined $tmp  && $tmp ne '' ) {
      $preview_link = "$tmp_url/$f";
      if ($file_type ne $gr_type) {
         $f_n .= ".$tmp";
         $preview_link .= ".$tmp";
      }
   }

   if (! defined $file_type) { $file_type = $html_type };

   &show_editor ("$d/$f", $preview_link, $f_t, $t);
 
   exit;
}

###########################################################################
sub show_dir {
###########################################################################
  my $file_type = shift;
  my $item1;
  my @old_f;
  my $dir = $field_dir_base;
  my $c = 0;

  if ($file_type eq $gr_type) {
     $dir = $img_dir;
  }
  elsif ($file_type eq $css_type) {
     $dir = $css_dir;
  }
  elsif ($file_type eq $tt_type) {
     $dir = $tt_dir;
  }
  elsif ($file_type eq $static_type) {
     $dir = $static_dir;
  }
  elsif ($file_type eq $html_type) {  
     $dir = "$field_dir_base/$field_dir";
     $file_type = $html_type;
  } 
  else { &error ("", "Chto-to sstrasstnoe.."); }

   
  opendir (DIR, $dir);
  @old_f = readdir DIR;
  closedir DIR;

  my @new_f;
  my $it;

  foreach $it (@old_f)
  {
    push @new_f, $it if ($it ne '' && -f "$dir/$it");
  }  

  undef @old_f;

   my $template = Template->new ({
        INCLUDE_PATH  => $include_path,
        RELATIVE => 1, 
        ABSOLUTE => 1,
        PRE_PROCESS => "$include_path/config",
      });

   my $vars = {
        'main_list'     => \@MAIN_LIST,
        'top_item'      => $top_item,
        'last_item'     => $last_item,
        'last_hash'     => $last_hash,
        'path'          => $p,
        'url'           => $url,
        'SITE_IP'       => $SITE_IP,
        'index'         => $index,
        'field'         => $field,
        'sub'           => $sub,
        'print_msg'     => $MSG{'to_print'},
        'page'          => $page,
        'left_nav'      => &get_left_nav(),

        'file_list'     => \@new_f,
        'f_type'        => $file_type,

        'FORM'          => \%FORM,
        'USER'          => $USER,
        'U_NAME'        => $name1,
        'valid_user'    => $valid_user,
        'superuser_mode'=> $superuser_mode,

                };
  print "Content-type: text/html\n\n";
  $template->process ('cp_filelist', $vars) || die $template->error(), "\n";
}

###########################################################################
sub forum_mng_form {
###########################################################################
 my $found = 0;

  my ($file_name, $dir, $gb_name_data) = &get_index_file_n_gb ($last_hash);
  my $f_n = "$dir/$file_name";
  if (! -e $f_n) { return; }

   open(MSGS, $f_n);
   @lines = <MSGS>;
   close(MSGS);

   foreach $line (@lines) {
     if ($line =~ /<!--top: (.*)--><li><a href="(.*)">(.*)<\/a> - <b>(.*)<\/b>\s+<i>(.*)<\/i>/) {
         $found = 1;
         push(@ENTRIES,$1);
         $SUBJECT{$1} = $3;
         $AUTHOR{$1} = $4;
         $DATE{$1} = $5;
      }
   }

   @SORTED_ENTRIES = (sort { $a <=> $b } @ENTRIES);
   $max = pop(@SORTED_ENTRIES);
   $min = shift(@SORTED_ENTRIES);
   
   if ($found == 0) {
      return;
   }
   
   print <<HTML;

<form name=f1 method="POST" action="http://$SITE_IP/$cpanel">
<INPUT TYPE=hidden NAME=act VALUE=brd>
<INPUT TYPE=hidden NAME=brd_act VALUE=brd_remove>
<INPUT TYPE=hidden NAME=path VALUE="$p">

<input type=hidden name="abrd_min" value="$min">
<input type=hidden name="abrd_max" value="$max">
<input type=hidden name="abrd_type" value="remove">

<table border>
<tr>
<th>$MSG{'047'}  </th><th>$MSG{'046'} </th><th>$MSG{'048'} </th><th>$MSG{'045'} </th><th>$MSG{'044'} </th><th>$MSG{'043'} </th></tr>
HTML


   
   foreach (@ENTRIES) {
      print <<HTML;
<tr>
<th><b>$_</b></th>
<td><input type=radio name="$_" value="all"></td>
<td><input type=radio name="$_" value="single"></td>
<td><a href="http://$SITE_IP/$index/$p?act=brd\&brd_act=brd_show_rec\&brd_num=$_">$SUBJECT{$_}</a></td>
<td>$AUTHOR{$_}</td>
<td>$DATE{$_}</td>
</tr>
HTML

   }
      
   print <<HTML;

</table>
<p>
<input type=submit value="Remove Messages"> <input type=reset>
</form>
<p><hr><br>
HTML

}


