{
'success';
}    

###########################################################################
sub get_url () {
###########################################################################
 my $l = '';
 my $p;

 $p = &get_path;
 $l = "http://$SITE_IP/$front_page" if ($p eq '');
 $l = "http://$SITE_IP/$front_page/$p" if ($p ne '');
 
 return $l;
}


###########################################################################
sub get_cp () {
###########################################################################
 my $l;
 my $p;

 $p = &get_path;
 $l = "http://$SITE_IP/$cpanel" if ($p eq '');
 $l = "http://$SITE_IP/$cpanel/$p" if ($p ne '');
 
 return $l;
}


###########################################################################
sub get_path () {
###########################################################################
 my $l = '';
 my ($here) = @_;
 my $f = 0;
 my $pp;
 my $ii = 0;
 my $cnt = $path_length ;

 if (defined $here && $here < 0) {$cnt--;}

 for ($ii=0; $ii< $cnt; $ii++) {
  
       if (!$f) {
          $f = 1;
          $l = $path[$ii];
       } 
       else {
          $l = "$l/$path[$ii]";
       }
  }
 
 return $l;
}
 

###########################################################################
sub in_out_table {
###########################################################################
 my $is_top = shift;
 my $coding_table = {};

  $coding_table = {
    USERS       =>'user_f',
    DESC        =>'desc',
    SEPARATOR   =>'separator',
    NEWS_TOP    =>'news_top',
    NEWS_BUTT   =>'news_butt', 
    NEWS_ON     =>'news_on', 
    GB_OFF      =>'gb_off',
    GB_NAME     =>'gb_name',
    DESC_FILE   =>'des_file',
    CSS         =>'css',
    INDEX_FILE  =>'file', 
    EMAIL       =>'email',
    WIKI        =>'WIKI',
    KEY_NAME    =>'key_name',
    COLOR       =>'color', 
    ACTIVE      =>'active',
    COMMON      =>'common',
    URL         =>'url',
    TT          =>'tt',
    TT_PRINT    =>'tt_print',
    NAV         =>'nav',
 };

 if (!$is_top) {
    $coding_table->{'PAGES'} = 'pages';
 }

 return $coding_table;
}

###########################################################################
sub out_in_table {
###########################################################################
 my $coding_table = {};

  $coding_table = {
    user_f      => 'USERS',
    desc        => 'DESC',
    separator   => 'SEPARATOR',
    news_top    => 'NEWS_TOP',
    news_butt   => 'NEWS_BUTT',
    news_on     => 'NEWS_ON',
    gb_off      => 'GB_OFF',
    gb_name     => 'GB_NAME',
    des_file    => 'DESC_FILE',
    css         => 'CSS',
    file        => 'INDEX_FILE',
    email       => 'EMAIL',
    WIKI        => 'WIKI',
    key_name    => 'KEY_NAME',
    color       => 'COLOR',
    active      => 'ACTIVE',
    pages       => 'PAGES',
    sub_name    => 'NAME',
    field_name  => 'NAME',
    common      => 'COMMON',
    url         => 'URL',
    tt          => 'TT',
    tt_print    => 'TT_PRINT',
    nav         => 'NAV',
  };


 return $coding_table;
}

###########################################################################
sub init_field () {
###########################################################################
 my $kk = shift;
 my $field = {};

 $field = {
    USERS       => "",
    NAME        => "",
    DESC        => "text here",
    SEPARATOR   => "",
    NEWS_TOP    => "<li>",
    NEWS_BUTT   => "<br>[<font size=-3 color=$linkcolor>$date</font>]<p>\n",
    NEWS_ON     => 0,
    GB_OFF      => 0,
    GB_NAME     => "",
    DESC_FILE   => "",
    CSS         => "",
    INDEX_FILE  => "",
    EMAIL       => "",
    KEY         => $kk,
    WIKI        => "",
    KEY_NAME    => "",
    COLOR       => "",
    ACTIVE      => 1,
    UPDATED     => 0,
    PAGES       => -1,
    RAW_LINE    => "",
    COMMON      => 1,
    URL         => "",
    TT          => "",
    TT_PRINT    => "",
    NAV         => "",
 };
 
 return $field;
}

###########################################################################
sub get_field_text () {
###########################################################################
 my $text = {};

 $text = {
    USERS       => $MSG{'003'},
    NAME        => $MSG{'004'},
    DESC        => $MSG{'005'},
    SEPARATOR   => "Separator",
    NEWS_TOP    => "",
    NEWS_BUTT   => "",
    NEWS_ON     => $MSG{'006'},
    GB_OFF      => $MSG{'007'},
    GB_NAME     => $MSG{'008'},
    DESC_FILE   => $MSG{'009'},
    CSS         => $MSG{'010'},
    INDEX_FILE  => $MSG{'011'},
    EMAIL       => $MSG{'012'},
    KEY         => $MSG{'013'},
    WIKI        => $MSG{'014'},
    KEY_NAME    => $MSG{'015'},
    COLOR       => $MSG{'016'},
    ACTIVE      => $MSG{'017'},
    UPDATED     => "",
    PAGES       => $MSG{'018'},
    RAW_LINE    => "",
    COMMON      => $MSG{'039'},
    URL         => $MSG{'073'},
    TT          => $MSG{'078'},
    TT_PRINT    => $MSG{'079'},
    NAV         => $MSG{'080'},

# add bove this line  
 };
 
 return $text;
}

###########################################################################
sub get_field_ct () {
###########################################################################
 my $text = {};
  $text = {
    USERS       =>'user_f',
    DESC        =>'desc',
    SEPARATOR   =>'separator',
    NEWS_TOP    =>'news_top',
    NEWS_BUTT   =>'news_butt', 
    NEWS_ON     =>'news_on', 
    GB_OFF      =>'gb_off',
    GB_NAME     =>'gb_name',
    DESC_FILE   =>'des_file',
    CSS         =>'css',
    INDEX_FILE  =>'file', 
    EMAIL       =>'email',
    WIKI        =>'WIKI',
    KEY_NAME    =>'key_name',
    COLOR       =>'color', 
    ACTIVE      =>'active',
    PAGES       =>'pages',
    COMMON      =>'common',
    URL         =>'url',
    TT          =>'tt',
    TT_PRINT    =>'tt_print',
    NAV         =>'nav',
 };


 return $text;
}

###########################################################################
sub get_field_help () {
###########################################################################
 my $help = {};

 $help = {
    USERS       => $MSG{'019'},
    NAME        => $MSG{'020'},
    DESC        => $MSG{'021'},
    SEPARATOR   => $MSG{'022'},
    NEWS_TOP    => $MSG{'023'},
    NEWS_BUTT   => $MSG{'024'},
    NEWS_ON     => $MSG{'025'},
    GB_OFF      => $MSG{'026'},
    GB_NAME     => $MSG{'027'},
    DESC_FILE   => $MSG{'028'},
    CSS         => $MSG{'029'},
    INDEX_FILE  => $MSG{'030'},
    EMAIL       => $MSG{'031'},
    KEY         => $MSG{'032'},
    WIKI        => $MSG{'033'},
    KEY_NAME    => $MSG{'034'},
    COLOR       => $MSG{'035'},
    ACTIVE      => $MSG{'036'},
    UPDATED     => "",
    PAGES       => $MSG{'037'},
    RAW_LINE    => "",
    COMMON      => $MSG{'040'},
    URL         => $MSG{'074'},
    TT          => $MSG{'075'},
    TT_PRINT    => $MSG{'076'},
    NAV         => $MSG{'077'},
 };
 
 return $help;
}


###########################################################################
sub parse_one_line () {
###########################################################################
  my ($top, $line) = @_;
  my $coding_table;
  my $coding_f = {};
  my $coding_s = {};
  my $n_fields = 0;
  my $c;

  $coding_f = {
    user_f      => 'USERS',
    field_name  => 'NAME',
    desc        => 'DESC',
    separator   => 'SEPARATOR',
    news_top    => 'NEWS_TOP',
    news_butt   => 'NEWS_BUTT',
    news_on     => 'NEWS_ON',
    gb_off      => 'GB_OFF',
    gb_name     => 'GB_NAME',
    des_file    => 'DESC_FILE',
    css         => 'CSS',
    file        => 'INDEX_FILE',
    email       => 'EMAIL',
    number      => 'KEY',
    WIKI        => 'WIKI',
    key_name    => 'KEY_NAME',
    color       => 'COLOR',
    active      => 'ACTIVE',
    common      => 'COMMON',
    url         => 'URL',
    tt          => 'TT',
    tt_print    => 'TT_PRINT',
    nav         => 'NAV',
 };

  $coding_s = {
    user_f      => 'USERS',
    sub_name    => 'NAME',
    desc        => 'DESC',
    separator   => 'SEPARATOR',
    news_top    => 'NEWS_TOP',
    news_butt   => 'NEWS_BUTT',
    news_on     => 'NEWS_ON',
    gb_off      => 'GB_OFF',
    gb_name     => 'GB_NAME',
    des_file    => 'DESC_FILE',
    css         => 'CSS',
    file        => 'INDEX_FILE',
    email       => 'EMAIL',
    WIKI        => 'WIKI',
    key_name    => 'KEY_NAME',
    color       => 'COLOR',
    active      => 'ACTIVE',
    pages       => 'PAGES',
    common      => 'COMMON',
    url         => 'URL',
    tt          => 'TT',
    tt_print    => 'TT_PRINT',
    nav         => 'NAV',
 };

  $coding_s->{'sub'} = 'KEY';

  if ($top > 0) {
     $coding_table = $coding_f;
  }
  else {
     $coding_table = $coding_s;
  }

  my $field = &init_field (-1);
  my @pairs = split(/\;/, $line);

  foreach $p_item (@pairs) {
     my ($key,$content) = split(/=/,$p_item,2);

      $content=~s/\n//gs;
      $content=~s/\r//gs;
      $content=~s/"/\&quot\;/gs;
      $content=~s/'/\&quot\;/gs;

     if (defined ${$coding_table}{$key}) {
        $c = ${$coding_table}{$key};
        $field->{$c} = $content;
     }
  }

  if (defined $field->{'KEY'}) {
     $n_fields++;
  }
  else {
     &error ("", "Field record invalid");
  }

  $field->{'RAW_LINE'} = $line;

  return $field;
} 

###########################################################################
sub parse_fields_file () {
###########################################################################

  my ($top, $desfilename) = @_;
  my $name;
  my $k_;
  my $p_item = '';
  my $f_item = '';
  my @Fields_list = ();

  open (DATA, "$start_path/$data_dir/$desfilename") ||
       &error (bad_data, "$desfilename : $! ");
  @fields = <DATA>;
  close(DATA);

  foreach $f_item (@fields) {

    chop($f_item) if $f_item=~ /\n$/;
    
    if ($f_item ne '' && !($f_item=~ /^\#/)) {
      $f_item =~s/\n//gs;
      $f_item=~tr/+/ /;
      $f_item=~s/\012//gs;
      $f_item=~s/
//gs;
      $f_item=~s/\015//gs;
      $f_item=~s/\+/ /gs;

      my $field = &parse_one_line ($top, $f_item);
      push @Fields_list, $field;    
    }
  }

  return @Fields_list;
}

###########################################################################
sub fix_field () {
###########################################################################
  my ($it, $p, $is_top, $report) = @_;
  my $desfile = $it->{"DESC_FILE"};
  my $file_pattern;

  $desfile =~ s/ //g;

  return if ($p eq '');
  return if ($desfile ne '');

  if (!$is_top) {
     my $pp = $p;
     $pp =~s/\//\_/gs; 
     $file_pattern = "sub_$pp";
  }
  else {
     $file_pattern = "des_$p";
  }

  $it->{"DESC_FILE"} = "$file_pattern.des";
#  &report ("fixed : $p, $is_top => ".$it->{"DESC_FILE"}) if ($report);
}

###########################################################################
sub get_field_by_path_item () {
###########################################################################
 my ($p_item, $fields_list) = @_;
 my $f = {};

 for (my $ii=0; $ii < scalar @$fields_list; $ii++) {
     $f = $fields_list->[$ii];
     
     if ($f->{"KEY"} == $p_item || $f->{"KEY_NAME"} eq $p_item) {
        return $f;
     }
 } 

 return undef;
}

###########################################################################
sub get_new_item () {
###########################################################################
 my ($path) = @_;
 my $ret = {};

 $ret = {
     UP_LIST    => undef,
     UP_HASH    => undef,
     UP_ITEM    => undef,
     HASH       => undef,
     LEVEL      => 0,
     DOWN_LIST  => undef,
     HAS_CH     => 0,
     PATH       => $path,
 };

 return $ret;
}

###########################################################################
sub run_parse () {
###########################################################################
  my $count;

  @MAIN_LIST = &parse_path ($p, @path);

  if (@MAIN_LIST) {
     $top_item = $MAIN_LIST[0];
     $last_item = $top_item;
     $count = scalar  @MAIN_LIST;
     
     if ($count) {
        $last_item = $MAIN_LIST[$count-1];
        $last_hash = $last_item->{"HASH"} if ($last_item);
     }

     if (!defined $last_hash->{'INDEX_FILE'} || 
         $last_hash->{'INDEX_FILE'} eq '') {
        if ($sub < 0) {
           $last_hash->{'INDEX_FILE'} = "index_".$field.".html";
        }
        else {
           my $pp = $p;
           $pp =~s/\//\_/gs; 
           $file_pattern =  "sub_$pp";
           $last_hash->{'INDEX_FILE'} = $file_pattern.".html";
        }
     }
  }
}

###########################################################################
sub get_index_file_n_gb () {
###########################################################################
   my $it = shift;
   my @ret = ("", "", "");

   return @ret if (!defined $it);

   if (defined $page && 
       $page ne '' && 
       $p ne '' &&
       $it->{'PAGES'} > 0 &&
       $page < $it->{'PAGES'}) {

      my ($fn, $ext) = split (/\./, $it->{'INDEX_FILE'}, 2);

      $fname = $fn."_".$page.".html";
      $gb_name_data = $it->{'GB_NAME'};
   }
   else {
      $fname = $it->{'INDEX_FILE'};
      $gb_name_data = $it->{'GB_NAME'};
   }

  $ret[0] = $fname;
  $ret[1] = "$field_dir_base/$field_dir";
  $ret[2] = $gb_name_data;

  return @ret;
}
 
###########################################################################
sub parse_path () {
###########################################################################
# globals:
# -------
# $sub
# $field
# $field_dir
# $real_path
# $real_names

  my ($p, @path) = @_;
  my $key = '';
  my $name = '';
  my $num = 0;
  my $f = 1;
  my @ret_items = ();
  my $desfile = $fields_file;
  my @fields_list = &parse_fields_file (1, $desfile);
  my $field_item = {};
  my $item = &get_new_item ("");
  my $ni;
  my $ppp = '';

  $sub = -1;
  $field = -1;

  $item->{"UP_LIST"} = [@fields_list];
  $item->{"HAS_CH"} = scalar @fields_list; 

  foreach $p_item (@path) {

     if (!@fields_list) { &error ("", "empty des file"); }
     $item->{"UP_HASH"} = $field_item if ($f < 1);

     $field_item = &get_field_by_path_item ($p_item, [@fields_list]);

     if (! defined $field_item) { &error ("", 
                                  "cannot parse path $p ($p_item)."); }

     $item->{"HASH"} = $field_item;
     $item->{"UP_LIST"} = [@fields_list] if (@fields_list);
     $item->{"LEVEL"} = $num;
 
     $key = $field_item->{"KEY"};

     if ($f == 1) {
        $field = $key;
        $ppp = $field;
        $field_dir = "dir_$field";
        $f = 0;
        &fix_field ($field_item, $ppp, 1, 1);
     }
     else {
        $sub = $key;
        $ppp = "$ppp/$key";
        &fix_field ($field_item, $ppp, 0, 1);
     }

     $item->{"PATH"} = $ppp;

     $desfile = $field_item->{"DESC_FILE"};
     if ($field_item->{"ACTIVE"} > 0 || 
         $FORM{'act'} eq 'tmp_view' || $valid_user == 1) {
        $real_path[$num] = $key;
        $real_names[$num] = $field_item->{'NAME'};
     }
     else {
        &error ("", "invalid path $p - data removed or deleted.");
     }
    
     $name  = "$start_path/$data_dir/$desfile";
     $num++;

     if (-e $name && !-d $name) {
        @fields_list = &parse_fields_file (-1, $desfile);
        $item->{"DOWN_LIST"} = [@fields_list] if (@fields_list);
        $item->{"HAS_CH"} = scalar @fields_list; 
     }
     elsif ($num < $path_length-1) {
        &error ("", "invalid path : $p");
     }

     
     push @ret_items, $item;
     $ni = &get_new_item ($ppp);
     $ni->{"UP_ITEM"} = $item;
     $item = $ni;
  }

  push @ret_items, $item if ($f); 

  return @ret_items;
}

