{
'success';
}    
###########################################################################
sub get_main_text {
###########################################################################
  my ($fname, $dir) = @_;
  my $fn = '';
  my $ext = '';
  my $tmp = '';
  my $empty = 'EMPTY';
  my $main_text = '';

   if ($to_show[0] ne '') { 

      foreach (@to_show) {
         $main_text .= $_;
      }
    
      return $main_text;
   } 

   if ($last_hash->{'INDEX_FILE'} eq '') {
      return $empty;
   }

   my ($fname, $dir, $gb_name_data) = &get_index_file_n_gb ($last_hash);

   if ($action eq 'tmp_view') {
      $fname = "$fname.$FORM{'tmp_name'}";
   }

   if (-e "$dir/$fname") {
      open (DATA, "$dir/$fname") || return; 
      while (<DATA>) { $main_text .= $_; } 
      close DATA;
   }

   return $main_text;
}

###########################################################################
sub get_css {
###########################################################################
  my $ret = undef;

  if ($last_hash->{'CSS'} ne '' && 
      -e "$css_dir/$last_hash->{'CSS'}") {
     $ret="$css_url/$last_hash->{'CSS'}";
  }
   
  return $ret;
}

###########################################################################
sub relocate_if_need {
###########################################################################
  my $url = "";

  return if (defined $action && $action ne '');

  if (defined $last_hash && 
      defined $last_hash->{'URL'} &&
      $last_hash->{'URL'} ne 'NONE') {

     $last_hash->{'URL'} =~ s/\ //g;
  }
  else { return;  }

  $url = $last_hash->{'URL'} if ($last_hash->{'URL'} ne '');
  return if ($url eq '');

  print "Location: $url\n\n";
  &report_user ("$ref SENT_TO '$url'");
  exit 0;
}

###########################################################################
sub process_act_main{
###########################################################################
  $action = $FORM{'act'};

  if ($action eq 'anketa') {
     &do_anketa;
     print "location: http://$SITE_IP/$index?get=thanks\n\n";
     exit 0;
  }

  if ($action eq 'gb_add') {
     &gb_add ("user", $last_hash->{"GB_NAME"});

     print "location: $url?page=$page\n\n";
     exit 0;
  }

  if ($action eq 'search') {
     &include_file ("tree.pl");
     @to_show = &do_search ($FORM{'key'});
  }

  if ($action eq 'brd') {
     @to_show = &do_brd;
  }

  if ($action eq 'wiki') {
     @to_show = &show_wiki;
  }

  if ($action eq 'file_edit') {
     @to_show = &do_wiki;
  }

   if ($action eq 'tmp_confirm') {
      &wiki_confirm;
      print "Location: $url?page=$page\n\n";
      exit 0;
   }
}

###########################################################################
sub get_left_nav {
###########################################################################
  my $lin_ = &get_path(-1);
  my $current_key = $field;
  my $items;
  my $ret = {}; 
  my ($nm, $it, $c);

  if ($field > -1) {
     $nm = $last_hash->{'NAME'};
     $it = $last_item->{'UP_HASH'}; # up hash
     $c = $p;

     if ($it->{'NAME'}) { 
        $nm = $it->{'NAME'}; 
        $c = $lin_;
     }

     $current_key = $sub;
  }

  $items = $last_item->{'UP_LIST'};
  if ($last_item->{'DOWN_LIST'} &&
      $last_item->{'HAS_CH'} > 0) {
     $items = $last_item->{'DOWN_LIST'};
     $lin_ = $p;
  }

  $ret = {
     'zagolovok'  => $nm,
     'up_path'    => $c,
     'current'    => $current_key,
     'list'       => $items,
     'lin_'       => $lin_,
  };


  return $ret;
}

###########################################################################
sub get_wiki_link {
###########################################################################
  my $res = '';

   if ($FORM{'act'} eq '' && $field ne '' && 
       $last_hash->{'WIKI'} eq 'wiki') {
      $res .= "<div align=center><a href=$url?page=$page\&act=wiki>";
      $res .= "<font color=red>EDIT</font></a></div>";
   }

  return $res;
}

###########################################################################
sub get_print_link {
###########################################################################
  my $print_var  = '';

  $print_var = "http://$site_ip/$front_page";

  if ($FORM{'get'}) {
     $print_var = $print_var."?get=$FORM{'get'}\&print=1>";
  }
  else { 
     $print_var = $print_var."/$p?page=$page\&print=1>";
  }

  return $print_var;
}

###########################################################################
sub get_guestbook {
###########################################################################
   my  ($gb_scr, $active,  $gb_gb_name, $mng_mode) = @_;
   my  $gb = &get_gb ($active, $gb_gb_name);

   my $ret = &gb_show_ret ($gb, $gb_gb_name, $mng_mode, $gb_scr);

   return $ret;
}
 
###########################################################################
sub get_pages {
###########################################################################

  my @res = undef;

  if ($last_hash->{'PAGES'} eq '' || 
      $last_hash->{'PAGES'} <= 0 ||
      $last_hash->{'PAGES'} eq '0' ) {

     return undef;
  }

  my $count = 0;

  while ($count ne $last_hash->{'PAGES'}) {

    push @res, $count;
    $count++;
  }

  return \@res;
}

###########################################################################
sub get_recent {
###########################################################################
  my @recent = &get_recent_list;
  my $res = '';

  if (@recent) {
     foreach (@recent) { $res .= $_;}
  }

  return $res;
}

###########################################################################
sub get_add_nav {
###########################################################################
   my $tmp_page = -2;
   my $res = '';

   if (!defined $last_hash->{'PAGES'} || $last_hash->{'PAGES'} < 0 )
   {   return ''; }

   if ($page ne '') {
      $tmp_page = $page - 1;
   }

   if ($tmp_page >= 0 ) {
      $res .= "<a href=http://$SITE_IP/$index/$last_item->{'PATH'}\?page=$tmp_page>";
      $res .= "$MSG{'back'}</a>";
   }  

   $tmp_page += 2;
   if ($tmp_page >= $last_hash->{'PAGES'} && $tmp_page > 0) {$tmp_page--;}

   $res .= "<a href=http://$SITE_IP/$index/$last_item->{'PATH'}\?page=$tmp_page>";
   $res .= "$MSG{'forth'}</a>";

   return $res;
}

###########################################################################
sub process_getfile{
###########################################################################
  my $getfile = $FORM{'get'};

  $GETFILE_NAMES{'contacts'} = $MSG{'auth'};
  $GETFILE_NAMES{'tree'} = $MSG{'tree'};
  $GETFILE_NAMES{'search'} = $MSG{'search'};
  $GETFILE_NAMES{'thanks'} = $MSG{'thanks'};
  $GETFILE_NAMES{'about'} = $MSG{'about'};

  if ($getfile eq 'contacts') {
     @to_show = &process_contacts;
     return;
  }

  if ($getfile eq 'tree') {
     &include_file ("tree.pl");
     @to_show = &process_tree;
     return;
  }

  if ($getfile eq 'search') {
     &include_file ("tree.pl");
     @to_show = &process_search;
     return;
  }

  if ($getfile eq 'thanks') {
     @to_show = &do_thanks;
     return;
  }

  if ($getfile eq 'about') {
     @to_show = &process_about;
     return;
  }
}


###########################################################################
sub get_referer {
###########################################################################
   my $ref = $ENV{'HTTP_REFERER'};
   my $item = '';
   my ($key, $content, $rr, $arg, $res_arg, $k);
   my @pairs = ();
   
   if ($ref =~ /$SITE_IP/i || $ref eq '' || !$ref) {
      # do nor record internal reference.
      return '';
   }
   else {

      ($rr, $arg) = split (/\?/, $ref, 2);
   
      if (defined $arg) {
         @pairs = split (/&/, $arg);
         $res_arg = '';
   
         foreach $item (@pairs) {
            if ($item =~ /\%/ ) {

                ($key, $content) = split(/=/, $item,2);

                $content=~tr/+/ /;
 
                while ($content =~ s/%(..)/pack("c",hex($1))/ei) {};
                $content=~s/\n//g;
                $content=~s/\r//g;
                $res_arg .= "'$content'";
             }
         }
   
         $ref = "$rr";
         if (defined $res_arg && $res_arg ne '') { $ref .= " TEXT=$res_arg"; }
      }
   }
   
   return $ref;
}


